<script setup lang="ts">
import { useSettingsStore } from 'store/settingsStore'
import { useMessage } from 'naive-ui'

const store = useSettingsStore()
const message = useMessage()

const handleClick = () => {
  message.info('Button Clicked')
}

const dummyRecipients = [
  { user_id: '001', name: 'Charlie Content' },
  { user_id: '002', name: 'Maria Lenderton' },
  { user_id: '003', name: 'Marty Mortgage' },
  { user_id: '004', name: 'Lee Loan' },
]

const recipientOptions = computed(() => {
  return dummyRecipients.map(recip => ({ label: recip.name, value: recip.user_id }))
})
</script>

<template>
  <div id="compliance-settings" class="flex flex-col bg-light-50 mb-2">
    <div id="compliance-notifications" class="px-4">
      <n-divider title-placement="left" class="!mt-2">
        Compliance Notifications
      </n-divider>
      <div class="space-y-xl mb-4 px-2">
        <div id="input">
          <div class="flex items-center">
            <span class="text-sm font-semibold">Compliance Notification Threshold</span>
            <n-popover class="max-w-[280px]" trigger="hover">
              <template #trigger>
                <i role="img" class="i-ant-design:info-circle-outlined block h-4 w-4 ml-1" />
              </template>
              <span class="text-xs">This number determines how many recipients a user may select when sending an email before a notification is sent to the selected notification receivers</span>
            </n-popover>
          </div>
          <n-input-number v-model:value="store.compliance_notification_threshold" clearable />
        </div>
        <div id="input">
          <div class="flex items-center">
            <span class="text-sm font-semibold">Compliance Notification Recipients</span>
            <n-popover class="max-w-[280px]" trigger="hover">
              <template #trigger>
                <i role="img" class="i-ant-design:info-circle-outlined block h-4 w-4 ml-1" />
              </template>
              <span class="text-xs">These users will receive notifications if any user passes the email send threshold set above</span>
            </n-popover>
          </div>
          <n-select
            v-model:value="store.email_tags"
            placeholder="Select Users"
            filterable
            clearable
            multiple
            :options="recipientOptions"
            max-tag-count="responsive"
            :reset-menu-on-options-change="false"
          />
        </div>
      </div>
    </div>
    <!-- Seperator -->
    <div id="compliance-disclaimers" class="px-4">
      <n-divider title-placement="left" class="!mt-2">
        Disclaimer
      </n-divider>
      <div class="flex flex-col space-y-xl px-2">
        <div class="flex items-center justify-between">
          <div class="flex items-center">
            <span class="text-base font-semibold">Override Default Disclaimer</span>
            <n-popover class="max-w-[280px]" trigger="hover">
              <template #trigger>
                <i role="img" class="i-ant-design:info-circle-outlined block h-4 w-4 ml-1" />
              </template>
              <span class="text-xs">Override the default disclaimer for your organization</span>
            </n-popover>
          </div>
          <n-switch v-model:value="store.compliance_override_default" size="medium" />
        </div>
        <div class="flex flex-col">
          <span class="text-sm font-semibold">Override Disclaimer Preview</span>
          <div class="text-xs max-h-60 overflow-y-auto border-1 border-arctic-50 px-4 py-2" :class="{ 'text-gray-300 cursor-not-allowed': store.compliance_override_default !== true }">
            {{ store.compliance_disclaimer_override_text }}
          </div>
        </div>
        <n-button class="w-full" :disabled="store.compliance_override_default === false" @click="handleClick">
          Compose Override Disclaimer
        </n-button>
      </div>
    </div>
  </div>
</template>
